VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RSIGS2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Implements PluginImportExport

Const tdcObject As Long = 11

Private Type Colour     ' 16 bytes
    r As Single
    g As Single
    b As Single
    a As Single
End Type

Private Type bbox       ' 32 bytes
    min As D3DVECTOR4
    max As D3DVECTOR4
End Type

'// vertex welding thresholds
'// these are from the TRK Exporter
'// probably found through trial n error, i certainly can't remember
'// but we'll use them seeing as they seem to work
Const gVertexWeldNormalThreshold As Double = 0.00002
Const gVertexWeldColourThreshold As Double = 0.0039
Const gVertexWeldUVThreshold As Double = 0.00002

Const IGF_MAX_RENDER_STAGES = (8)
Const IGF_MAX_LEGACY_TEXTURE_NAME = (32)
Const IGF_MAX_SHADER_NAME = (128)
Const IGF_MAX_SURF_TYPE_NAME = (128)
Const IGF_MAX_MATERIAL_COMMENT = (256)
Const IGF_MAX_MATERIAL_NAME = (128)
Const IGF_MAX_EFFECT_NAME = (32)
Const IGF_MAX_LIGHTGLOW_TYPE = (32)
Const IGF_MAX_SEQUENCE_MODE = (32)
Const IGF_MAX_OBJECT_NAME = (32)
Const IGF_MAX_EXPORTED_BONES = (8)
Const IGF_MAX_HEADER_COMMENT = (64)
Const IGF_MAX_HEADER_DESCRIPTOR = (16)
Const IGF_MAX_CHILDREN = (24)
Const IGF_MAX_FACE_TAG_DESCS = (256)


Private Type IGDataBlock
    mName(IGF_MAX_OBJECT_NAME - 1) As Byte ';     // name of data block
    id As Long
    data As Long
    Size As Long                        ' 44 bytes
End Type

Private Type IMUVModify

    Apply As Long   ';             // apply this modification or not

    U As Single
    v As Single
    w As Single
    H As Single
    UVWTM(8) As Single
End Type


Private Type IGDataBlockContainer
    NumBlocks As Long
    offsetBlocks As Long
    pad0(IGF_MAX_OBJECT_NAME - 1) As Byte
    pad1(1) As Long                             ' 48 bytes
End Type

Private Type texturenames
    SizeStringtable As Long
    mNumStrings As Long
End Type

Private Type GenericSceneData       ' 80 bytes

    Type As Long

    ICustomParam(3) As Long
    FCustomParam(3) As Single

    mExtraData As IGDataBlockContainer

End Type

Private Type GenericSceneItem

    mName(IGF_MAX_OBJECT_NAME - 1) As Byte
    NameUID As Long

    TM As D3DMATRIX
    
    BoundingBox As bbox ';               // bounding volume, if applicable
    
    parent As Long ';                   // parent instance node, NULL if none
    mData As GenericSceneData
    
End Type

Private Type IGRenderStage      ' 104 bytes
    mTextureName As Long    ' 4

    mPadding(IGF_MAX_LEGACY_TEXTURE_NAME - 5) As Byte ' 28

    mUVChannelIndex As Long

    ''// UV engine-side operations
    mFilterMode As Long
    mUVOperation As Long
    mUVWrapU As Long
    mUVWrapV  As Long

    mMipLODBias As Single

    ''// UV page animation
    mAnimateUVs  As Long
    mNumFrames As Long
    mFPS As Long

    ''// UV scrolling per-stage setup
    mScrollUVs As Long
    mScrollU As Single
    mScrollV As Single ';             '// rate to scroll per second

    ''// arbitary arguments setup in UI
    ''// purpose dependant on shader and operation mode
    mArguments(5) As Single
End Type

Private Type IGPulseGlowConfig  ' 88 bytes

    TargCol As Colour
    Mode As Long

    '// if in pulse mode...
    Phase As Single
    Period As Single
    Amplitude As Single

    '// if in random mode...
    RptTimeMin As Single
    RptTimeMax As Single
    ExeTimeMin As Single
    ExeTimeMax As Single
    ActivationTime As Single
    '// if in sequenced mode...
    SeqMode(IGF_MAX_SEQUENCE_MODE - 1) As Byte

    VertexModify As Long
End Type

Private Type IGMaterial ' 1780 bytes

    '// original name of material from editor UI
    '// mainly used for tracking and debugging mtls after conversion
    mName(IGF_MAX_MATERIAL_NAME - 1) As Byte ' 128

    '// name of active shader
    ShaderName(IGF_MAX_SHADER_NAME - 1) As Byte ' 128

    '// set of multipass rendering stages
    NumRenderStages As Long ' 1-8
    RenderStage(IGF_MAX_RENDER_STAGES - 1) As IGRenderStage ' 8*104

    '// engine behavior setup
    NeverOcclude As Long
    SortPriority As Long
    ZBias As Long
    AlphaTestMode As Long
    AdditiveAlphaStrength As Long
    ZBufferMode As Long
    BackfaceCull As Long
    TwoSided As Long
    ViewFacing As Long

    '// visible distance mod for this surface
    VisMod As Long  ' + 40

    '// string description of surface type
    SurfaceType(IGF_MAX_SURF_TYPE_NAME - 1) As Byte ' + 128


    '// special effects behaviors
    UseLightGlow  As Long
    UsePulseGlow As Long
    LightGlowType(IGF_MAX_LIGHTGLOW_TYPE - 1) As Byte '+ 32
    
    PulseGlowConfig As IGPulseGlowConfig        ' + 88


    '// behaviors promoted from comment field toggles
    Unfoggable As Long
    Force32Bit  As Long


    '// colouring and behavior of material surface
    Ambient As Colour
    Diffuse As Colour
    Emissive As Colour
    EmissiveStrength As Single
    Specular As Colour
    SpecularPower As Single


    '// lightmap generation support
    LMCastShadows As Long
    LMGenerateShadows As Long
    LMKeepVertexColours As Long
    LMTexelsPerMetre As Single

    '// generic 'comment' string
    Comment(IGF_MAX_MATERIAL_COMMENT - 1) As Byte '+ 256

    ExtraData As IGDataBlockContainer ' ;                 '// per-mtl extra data
End Type


Private Type FaceTagDescs
    strings(255, 31) As Byte
End Type

Private Type IGVertexBoneBinding

    Bone As Long ';                     // bone exerting influence
    Weight As Single    ';                    // weight applied to bone, range 0..1
                                            ' // NB: all weights in a vertex binding array must add up to 1.0
End Type

Private Type IGVertex   ' 172 bytes

    Point As D3DVECTOR4 ';                     // vertex position in object space
    Normal As D3DVECTOR4 ';                    // vertex normal
    NumValidUVs As Long ';               // number of valid UV entries in mUV[]
    uv(IGF_MAX_RENDER_STAGES - 1) As D3DVECTOR2 ']; // UVs per render stage
    Colour As Colour    ';                    // colour per vertex

    '// material binding (from owning face)
    Material As Long        ';                 // assigned material

    '// skinning information
    NumBones As Long    ';                  // number of bones this vertex is attached to
    
    BoneBinding(IGF_MAX_EXPORTED_BONES - 1) As IGVertexBoneBinding ' 8*16

    Reserved As Long    ';                  // for future / export / conversion use
    ExtraData As IGDataBlockContainer ';                 // per-vertex extra data
End Type

Private Type IGTriangle

    Vertex(2) As Long ';                // three vertices making up this triangle
    Normal As D3DVECTOR4
    HiddenEdges As Long '               // edge visibility flags (EDGE_V0_V1_HIDDEN, etc)

    Material As Long '                 // assigned material

    SMGroup As Long                   '// smoothing group ID from editor (if applicable - eg. MAX)


    TagId As Long ';                     // per-face tag
    ExtraData As IGDataBlockContainer   ';                 // per-face extra data

End Type

Private Type IGGeom ' 96 bytes

    IsSkinned As Long   ';                 // has skinning information in the vertices

    NumVertices As Long ';               // number of vertices in mVertexList
    Vertices As Long        ';                 // array of vertices used by this node

    NumTriangles As Long    ';              // number of triangles in mTriangleList
    Triangles As Long   ';                // triangles forming the surface of this mesh

    BoundingBox As bbox ';               // bounding volume for all node verts

    ExtraData As IGDataBlockContainer   ';                 // per-node extra data
End Type

Private Type IGGeometryLOD ' 40 bytes

    VisibleDistance As Single       ';           // distance that LOD is visible
    pGeometry As Long                ';                 // geometry representing the LOD
    ExtraData As IGDataBlockContainer  ';                 // lod-level extra data
End Type

Private Type IGInstance
    sName(IGF_MAX_OBJECT_NAME - 1) As Byte ' // original name of object in editor
    NameUID As Long     ';                   // unique ID for this object name, used for fast matching or hashing

    NumLODs As Long     ';                   // number of LODs stored in mGeometry
    
    pGeometry As Long 'IGGeometryLOD  ';                 // pointers back to geometry LODs

    TM As D3DMATRIX         ';                        // (initial) transformation

    '// hierarchy management
    pParent As Long          ';                   // parent node, NULL if root of hierarchy
    NumChildren As Long     ';               // number of children in mChildren list
    pChildren(IGF_MAX_CHILDREN - 1) As Long  ';   // 1 or more children instances

    ExtraData As IGDataBlockContainer       ';                 // per-instance extra data

End Type

Private Type IGBone
    sName(IGF_MAX_OBJECT_NAME - 1) As Byte ' // original name of object in editor
    NameUID As Long     ';                   // unique ID for this object name, used for fast matching or hashing

    TM As D3DMATRIX         ';                        // (initial) transformation

    '// hierarchy management
    pParent As Long          ';                   // parent node, NULL if root of hierarchy
    NumChildren As Long     ';               // number of children in mChildren list
    pChildren(IGF_MAX_CHILDREN - 1) As Long  ';   // 1 or more children instances

    ExtraData As IGDataBlockContainer       ';                 // per-instance extra data

End Type

Private Type IGSHead

    magic As Long
    version As Long
    IGDescriptor(15) As Byte
    CommentField(63) As Byte

    DataStart As Long

    '// geometry tables
    NumInstances As Long
    pInstances As Long

    NumGeometry As Long
    pGeometry As Long


    NumBones As Long
    pBones As Long

    '// data pointer table follows
    NumMaterials As Long
    pMaterials As Long

    NumLights As Long
    pLights As Long
    AmbientColour As Colour

    NumSplines As Long
    pSplines As Long

    NumGenericItems As Long
    pGenericItems As Long
    '160
    ExtraData As IGDataBlockContainer
    DataPtr As Long
    
End Type

Private Type LODArray
    geomlod() As IGGeometryLOD
End Type

Private Type TriangleArray
    Tris() As IGTriangle
End Type
Private Type VertArray
    Verts() As IGVertex
End Type


Enum lodType
    None
    Auto
    custom
End Enum

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' module variables

Dim lods As lodType
Dim head As IGSHead
Dim instances() As IGInstance
Dim bones() As IGBone
Dim instLODs() As LODArray
Dim geom() As IGGeom
Dim geomTri() As TriangleArray
Dim geomVert() As VertArray
Dim TexData As IGDataBlock
Dim TxNam As texturenames
Dim Tx() As String
Dim TxTable() As String

Dim materials() As IGMaterial
Dim nLods As Long
Dim mScaleFactor As Single
Dim gid As Long

Const GrpId = "Rail Sim"
Const matId = "RailSimX"
Const ShaderId = "Rail Sim"
Const TxId = "Tx Alpha"
Const APrId = "Alpha Pr"
Dim iMatId As Long, iGrpId As Long, iShaderId As Long, iTxId As Long, iAPrId As Long
Private CSG As CSG

Private MatOpt() As String

Private sc As CSGGroup
Private pExportGroup As CSGGroup
'Private ca As CanvasApplication2
Private fn As String
Private f As frmOptions
Private nCustom As Long
Private gcustom(9) As CSGGroup

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, _
                                                                     pSrc As Any, _
                                                                     ByVal ByteLen As Long)

       
Public Sub Run()
    Dim i As Long
    Dim s As String

    Select Case CSG.ApplicationState.OptionUnits
    Case CSGCentimeters
        mScaleFactor = 0.01
    Case CSGFeet
        mScaleFactor = 0.3048
    Case CSGMeters
        mScaleFactor = 1!
    End Select
    
    lods = f.LType
    
    'if there is a group selected export only that group and it's children
    'this is the current standard for 3D Canvas exports. You could optionally
    'look at all groups selected and export only those groups.
    If Not pExportGroup Is CSG.ApplicationState.Scene Then
        ExportIGS fn, pExportGroup
    Else 'otherwise export the entire scene
        ' scan for "Main" in root group'

        For i = 0 To sc.GetChildren.GetSize - 1
            s = LCase$(sc.GetChildren.GetElement(i).Name)
            If s = "main" Then
                ExportIGS fn, sc.GetChildren.GetElement(i)
                Exit Sub
            End If
        Next
        MsgBox "Select a group to export or name one group 'Main'"
    End If

End Sub

Private Sub PluginImportExport_Export(ByVal ExportFileName As String _
, ByVal ExportGroup As CSGGroup _
, ByVal SceneGraph As CSG _
, ByVal ApplicationState As CSGApplicationState _
, ByRef UserDataSingles() As Single _
, ByRef UserDataLongs() As Long _
, ByRef UserDataString As String)

    Set sc = SceneGraph.ApplicationState.Scene
    Set pExportGroup = ExportGroup
    
    ' material fields
    iShaderId = sc.GetMaterialCustomFieldID(ShaderId)
    If iShaderId < 0 Then
        iShaderId = sc.i_AddMaterialCustomField(ShaderId)
    End If
    
    iTxId = sc.GetMaterialCustomFieldID(TxId)
    If iTxId < 0 Then
        iTxId = sc.i_AddMaterialCustomField(TxId)
    End If
    
    iAPrId = sc.GetMaterialCustomFieldID(APrId)
    If iAPrId < 0 Then
        iAPrId = sc.i_AddMaterialCustomField(APrId)
    End If
    
    iMatId = sc.GetMaterialCustomFieldID(matId)
    If iMatId < 0 Then
        iMatId = sc.i_AddMaterialCustomField(matId)
    End If
    
    ' group field
    iGrpId = sc.GetGroupCustomFieldID(GrpId)
    If iGrpId < 0 Then
        iGrpId = sc.i_AddGroupCustomField(GrpId)
    End If
    
    
    Set f = New frmOptions
    Set CSG = SceneGraph
    Set f.plug = Me
    fn = ExportFileName
    
    f.Show vbModal
    
    Unload f
    Set f = Nothing
    
End Sub

'*********************************************************************************
' Implemented Functions
'*********************************************************************************


'*********************************************************************************
' Purpose: Provides a description of the type of file imported/exported
'          This is the description that will be displayed in 3D Canvas
'*********************************************************************************

Private Property Get PluginImportExport_FileTypeDescription() As String
    PluginImportExport_FileTypeDescription = "RailSim/RailWorks Geometry (Alternative) (.IGS)"
End Function

'*********************************************************************************
' Purpose: Provides the File type (extension) of the type of file imported/exported
'*********************************************************************************

Private Property Get PluginImportExport_FileType() As String
    PluginImportExport_FileType = "IGS"
End Function


Private Sub PluginImportExport_Import(ByVal ImportFileName As String _
, ByVal ImportGroup As CSGGroup _
, ByVal SceneGraph As CSG _
, ByVal ApplicationState As CSGApplicationState _
, ByRef UserDataSingles() As Single _
, ByRef UserDataLongs() As Long _
, ByRef UserDataString As String)

End Sub

'*********************************************************************************
' Purpose: Is Import Supported?
'*********************************************************************************

Private Property Get PluginImportExport_SupportImport() As Boolean
    PluginImportExport_SupportImport = False
End Function

'*********************************************************************************
' Purpose: Is Export Supported?
'*********************************************************************************

Private Property Get PluginImportExport_SupportExport() As Boolean
    PluginImportExport_SupportExport = True
End Function

'*********************************************************************************
' Purpose: Provides the name of the plug-in author
'*********************************************************************************

Private Property Get PluginImportExport_Author() As String
    PluginImportExport_Author = "Paul Gausden 2011"
End Function

'*********************************************************************************
' Purpose: Returns the icon
'*********************************************************************************

Private Property Get PluginImportExport_Icon() As StdPicture
    
    Set PluginImportExport_Icon = Nothing ' LoadResPicture(101, vbResBitmap)
    
End Property

'*********************************************************************************
' Purpose: Identify which versions of 3D Canvas the export function of this
'          plugin should be availabe for
'
'          For user created plug-ins this is ignored - Pro is always required
'*********************************************************************************

Private Property Get PluginImportExport_Cost() As CSGFunctionCost
    PluginImportExport_Cost = CSGFunctionTrainworks
End Function

'*********************************************************************************
' Purpose: Indicate into which import/export class this plugin should be sorted
'          on the import/export menus
'*********************************************************************************

Private Property Get PluginImportExport_PluginClass() As CSGPluginImportExportClass
    PluginImportExport_PluginClass = CSGPluginImportExportTrainSimulator
End Function



'*********************************************************************************
' Purpose:      Exports a IGS File
'*********************************************************************************

Private Sub ExportIGS(strOutputFile As String, cgExportGroup As CSGGroup)

    Dim i As Integer, offset As Long, matoffset As Long, matlen As Long
    Dim voffset As Long, vlen As Long
    Dim goffset As Long
    Dim topG As selGroup, gp As selGroup
    Dim instID As Long, iid As Long, z As Long, i1 As Long, i2 As Long
    Dim b() As Byte, matId As Long, str As Long, s As String, lname As Long
    Dim txUse() As Boolean
    Dim distance As Long
    Dim bOK As Boolean
    
    Set topG = New selGroup

    ' look for custom lods

    ' inital size
    ReDim materials(50)
    ReDim Tx(50)
    ReDim TxTable(100)
    
    If lods = Auto Then
        If ScanModel(cgExportGroup, 1, 100, topG) Then bOK = True
        If ScanModel(cgExportGroup, 2, 400, topG) Then bOK = True
        If ScanModel(cgExportGroup, 3, 1000, topG) Then bOK = True
    ElseIf lods = custom Then
        ' find similar groups
        FindLods cgExportGroup
        
        lname = Len(cgExportGroup.Name)
        
        For i1 = 0 To nCustom - 1
        
            If i1 < (nCustom - 1) Then
                iid = GetDist(gcustom(i1 + 1).Name, lname)
            Else
                iid = 1000
            End If
            
            If ScanModel(gcustom(i1), i1 + 1, iid, topG) Then bOK = True
        Next
        
    Else
        bOK = ScanModel(cgExportGroup, 1, 1000, topG)
    End If
    
    If bOK Then
        'get the next available file
        i = FreeFile
    
        'open the main OBJ file for writing
        On Error Resume Next
        Kill strOutputFile
        On Error GoTo 0
        Open strOutputFile For Binary Lock Write As #i
        f.AddList "Processing Geometry (" & head.NumInstances & " blocks)"
            
        head.version = 151
        head.magic = &H4647494B
        ToByte head.IGDescriptor, "SHAPE"
        ToByte head.CommentField, "3D Canvas IGS Export by Paul Gausden 2011"
        'ToByte head.CommentField, "Exported by 3D Canvas"
        ToByte TexData.mName, "Texture name table"
        TexData.id = 2
        TexData.data = 44
        head.AmbientColour.r = 0.39607847
        head.AmbientColour.g = 0.39607847
        head.AmbientColour.b = 0.39607847
        head.AmbientColour.a = 0!
        
        ReDim instances(head.NumInstances - 1)
        If head.NumBones > 0 Then ReDim bones(head.NumBones - 1)
        ReDim instLODs(head.NumInstances - 1)
        ReDim geom(head.NumGeometry - 1)
        ReDim geomTri(head.NumGeometry - 1)
        ReDim geomVert(head.NumGeometry - 1)
        
        ' export all groups
        gid = -1
        For Each gp In topG.children
            StoreInst gp, instID, -1
            instID = instID + 1
        Next


        f.AddList "Adjusting pointers"
        ' adjust texture table for materials
        TxNam.mNumStrings = 0
        TxNam.SizeStringtable = 0
        
        For matId = 0 To head.NumMaterials - 1
                
            For z = 0 To materials(matId).NumRenderStages - 1
                
                str = materials(matId).RenderStage(z).mTextureName
                
                If str > 0 Then
                    s = Tx(str - 1)
                    TxTable(TxNam.mNumStrings) = s
                    TxNam.mNumStrings = TxNam.mNumStrings + 1
                    TxNam.SizeStringtable = TxNam.SizeStringtable + Len(s) + 1
                    materials(matId).RenderStage(z).mTextureName = z + matId * 100 + 10
                End If
            Next
        Next

        ' correct array lengths
        ReDim Preserve materials(head.NumMaterials - 1)
        ReDim Preserve Tx(TxNam.mNumStrings - 1)
        ' adjust pointers before output
        
        offset = Len(head)
        head.pMaterials = offset
        matoffset = offset
        matlen = Len(materials(0))
        offset = offset + matlen * head.NumMaterials
        vlen = Len(geomVert(0).Verts(0))
        
        ' vertices
        For iid = 0 To head.NumGeometry - 1
            geom(iid).Vertices = offset
            offset = offset + vlen * geom(iid).NumVertices
            For z = 0 To geom(iid).NumVertices - 1
                geomVert(iid).Verts(z).Material = geomVert(iid).Verts(z).Material * matlen + matoffset
            Next
        Next
        
        ' triangles
        For iid = 0 To head.NumGeometry - 1
            geom(iid).Triangles = offset
            offset = offset + Len(geomTri(iid).Tris(0)) * geom(iid).NumTriangles
            voffset = geom(iid).Vertices
            For z = 0 To geom(iid).NumTriangles - 1
                geomTri(iid).Tris(z).Material = geomTri(iid).Tris(z).Material * matlen + matoffset
                geomTri(iid).Tris(z).Vertex(0) = voffset + vlen * geomTri(iid).Tris(z).Vertex(0)
                geomTri(iid).Tris(z).Vertex(1) = voffset + vlen * geomTri(iid).Tris(z).Vertex(1)
                geomTri(iid).Tris(z).Vertex(2) = voffset + vlen * geomTri(iid).Tris(z).Vertex(2)
            Next
        Next
        
    '   GEOMETRY OFFSET
        head.pGeometry = offset
        goffset = offset
        offset = offset + Len(geom(0)) * head.NumGeometry
        
        ' instance lods
        For iid = 0 To head.NumInstances - 1
            instances(iid).pGeometry = offset
            offset = offset + Len(instLODs(iid).geomlod(0)) * instances(iid).NumLODs
            For z = 0 To instances(iid).NumLODs - 1
                instLODs(iid).geomlod(z).pGeometry = goffset + instLODs(iid).geomlod(z).pGeometry * Len(geom(0))
            Next
        Next
        
        
        i1 = Len(instances(0))
        i2 = offset
        head.pInstances = i2
        
        
        ' parent and child pointers
        For iid = 0 To head.NumInstances - 1
            If instances(iid).pParent < 0 Then
                instances(iid).pParent = 0
            Else
                instances(iid).pParent = instances(iid).pParent * i1 + i2
            End If
            For z = 0 To instances(iid).NumChildren - 1
                instances(iid).pChildren(z) = instances(iid).pChildren(z) * i1 + i2
            Next
        Next
        
        offset = offset + i1 * head.NumInstances
        
        ' bones
        If head.NumBones > 0 Then
            i1 = Len(bones(0))
            i2 = offset
            head.pBones = i2
            ' parent and child pointers
            For iid = 0 To head.NumBones - 1
                If bones(iid).pParent < 0 Then
                    bones(iid).pParent = 0
                Else
                    bones(iid).pParent = bones(iid).pParent * i1 + i2
                End If
                For z = 0 To bones(iid).NumChildren - 1
                    bones(iid).pChildren(z) = bones(iid).pChildren(z) * i1 + i2
                Next
            Next
            
            offset = offset + i1 * head.NumBones
        End If
        ' textures
        If TxNam.mNumStrings > 0 Then
            head.ExtraData.NumBlocks = 1
            head.DataPtr = offset
        End If
        
        f.AddList "Writing to " & strOutputFile & "..."

        ' output to file

        Put #i, , head
        Put #i, , materials
        
        For iid = 0 To head.NumGeometry - 1
            Put #i, , geomVert(iid).Verts
        Next
        
        For iid = 0 To head.NumGeometry - 1
            Put #i, , geomTri(iid).Tris
        Next
        
        Put #i, , geom
        
        For iid = 0 To head.NumInstances - 1
            Put #i, , instLODs(iid).geomlod
        Next
        
        Put #i, , instances
        If head.NumBones > 0 Then
            Put #i, , bones
        End If
        Put #i, , TexData

        If TxNam.mNumStrings > 0 Then
            ' string offsets
            offset = 0
            Put #i, , TxNam
            For iid = 0 To TxNam.mNumStrings - 1
                Put #i, , offset
                offset = offset + Len(TxTable(iid)) + 1
            Next
            ' strings
            For iid = 0 To TxNam.mNumStrings - 1
                ' put texture names
                b = StrConv(TxTable(iid), vbFromUnicode)
                Put #i, , b
                Put #i, , CByte(0)
            Next
        End If

        Close i
        f.AddList "Export Finished."
    Else
        MsgBox "Nothing to Export"
    
    End If
    
    ' clear up
    Erase instances
    Erase bones
    Erase materials
    Erase instLODs
    Erase geom
    Erase geomTri
    Erase geomVert

End Sub

' store instance and geometry into the arrays
Private Sub StoreInst(g As selGroup, ByRef id As Long, ByVal pid As Long)
    Dim gChild As selGroup, t(3, 3) As Single
    Dim tNew As CSGMatrix
    Dim cmFace As CSGFace
        
    'Debug.Print id
    f.AddList "Block " & id
    ' get matrix
    If pid > -1 Then
        g.cGroup.GetTransform g.cGroup.parent, 0, tNew
        CopyMemory t(0, 0), tNew, 16 * Len(t(0, 0))
        
        With instances(pid)
        
            If .NumChildren < IGF_MAX_CHILDREN Then
                .pChildren(.NumChildren) = id
                .NumChildren = .NumChildren + 1
            End If

        End With
    Else
        t(0, 0) = 1#
        t(1, 1) = 1#
        t(2, 2) = 1#
        t(3, 3) = 1#
    End If
    
    
    With instances(id)
        .NameUID = id + 1
        .pGeometry = id
        .NumLODs = 1
        .pParent = pid
        
        t(0, 3) = t(0, 3) * mScaleFactor
        t(1, 3) = t(1, 3) * mScaleFactor
        t(2, 3) = t(2, 3) * mScaleFactor
        
        DXCopyMemory .TM, t(0, 0), 64
        ToByte .sName, g.GrpName
    End With
    
    ' single lod
    ReDim instLODs(id).geomlod(0)
    
    ' no mesh?
    If g.cMesh Is Nothing Then
        Set g.cMesh = CSG.CreateShape
        With g.cMesh
            .AddOptimizedPointXYZ CSG.x_Functions.CreateVector(0, 0, 0)
            .AddOptimizedPointXYZ CSG.x_Functions.CreateVector(0, 0, -0.0001)
            .AddOptimizedPointXYZ CSG.x_Functions.CreateVector(0.0001, 0, -0.0001)
            .AddOptimizedNormalXYZ CSG.x_Functions.CreateVector(0, -1, 0)
            .AddOptimizedTextureCoordinateUV CSG.x_Functions.CreateUV(0, 0)
            .AddOptimizedTextureCoordinateUV CSG.x_Functions.CreateUV(0, 1)
            .AddOptimizedTextureCoordinateUV CSG.x_Functions.CreateUV(1, 1)
            Set cmFace = .CreateFace
            cmFace.AddPointID 0, 0, 0
            cmFace.AddPointID 1, 0, 1
            cmFace.AddPointID 2, 0, 2
            'cmFace.ApplyMaterial cmDummyMaterial
            Set cmFace = Nothing
        End With
        ' mark to use material 0 in exportmesh sub
        g.Added = True
    End If
    
    gid = gid + 1
    ExportMesh g, gid
    
    With instLODs(id).geomlod(0)
        .VisibleDistance = 700!
        .pGeometry = gid
    End With
    
    ' scan the child groups
    pid = id
    
    For Each gChild In g.children
        id = id + 1
        StoreInst gChild, id, pid
    Next
    
End Sub
' store bone info into the arrays
Private Sub StoreBone(g As selGroup, ByRef id As Long, ByVal pid As Long)
    Dim gChild As selGroup, t(3, 3) As Single
    Dim tNew As CSGMatrix
        
    'Debug.Print id
    f.AddList "Block " & id
    ' get matrix
    If pid > -1 Then
        g.cGroup.GetTransform g.cGroup.parent, 0, tNew
        CopyMemory t(0, 0), tNew, 16 * Len(t(0, 0))
        
        With instances(pid)
        
            If .NumChildren < IGF_MAX_CHILDREN Then
                .pChildren(.NumChildren) = id
                .NumChildren = .NumChildren + 1
            End If

        End With
    Else
        t(0, 0) = 1#
        t(1, 1) = 1#
        t(2, 2) = 1#
        t(3, 3) = 1#
    End If
    
    
    With bones(id)
        .NameUID = id + 1
        .pParent = pid
        
        t(0, 3) = t(0, 3) * mScaleFactor
        t(1, 3) = t(1, 3) * mScaleFactor
        t(2, 3) = t(2, 3) * mScaleFactor
        
        DXCopyMemory .TM, t(0, 0), 64
        ToByte .sName, g.GrpName
    End With
    
    
    ' scan the child groups
    pid = id
    
    For Each gChild In g.children
        id = id + 1
        StoreBone gChild, id, pid
    Next
    
End Sub



'*********************************************************************************
' Purpose:      Exports a group
'               Note that this uses recursion.
'*********************************************************************************

Private Function ScanModel(cgExportGroup As CSGGroup, lod As Long, dist As Long, ByRef parent As selGroup) As Boolean

    Dim cgaGroupList As CSGGroupArray
    Dim lngGroup As Long, lngObject As Long
    Dim coaObjectList As CSGShapeArray
    Dim nObj As Long, i As Long
    Dim coObject As CSGShape, coX As CSGShape, coY As CSGShape
    Dim selG As selGroup
    Dim s As String, parts() As String
    Dim bExport As Boolean
    
    
    ' selected group
    Set selG = New selGroup
    Set selG.cGroup = cgExportGroup
    Set selG.parent = parent
    

    ''''''''''''''''''''''''''''''''''''''''''''''''''
    'get the children of this group
    Set cgaGroupList = cgExportGroup.GetChildren
    
    If cgaGroupList.GetSize > 0 Then
        
        'export the child groups recursively
        For lngGroup = 0 To cgaGroupList.GetSize - 1
            If ScanModel(cgaGroupList.GetElement(lngGroup), lod, dist, selG) Then ScanModel = True
        Next
    
    End If
    
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' scan objects in the group
    'get the objects of this group
    Set coaObjectList = cgExportGroup.GetShapes
    nObj = coaObjectList.GetSize
    
    Set coX = Nothing
    'export the objects as single object
    For lngObject = 0 To nObj - 1
        'get Object lngObject
        Set coObject = coaObjectList.GetElement(lngObject)
            
        'if what we found was an exportable object
        If coObject.RepresentativeEntityType = CSGEShape Then
        
            If lods <> Auto Or SizeOK(coObject, dist) Then
                
                bExport = True
                
                For i = 0 To coObject.GetMaterialCount - 1
                    If InvalidMaterial(coObject.GetMaterial(i)) Then
                        f.AddList "Material " & (i + 1) & " in " & cgExportGroup.Name & "/" & coObject.Name & " does not have a texture - excluded from export."
                        bExport = False
                        Exit For
                    End If
                Next
                ' export
                If bExport Then
                    If coX Is Nothing Then
                        Set coX = CSG.CreateShape
                    End If
                    coX.AddShape coObject
                End If
            Else
                ' include this group anyway, even if no geometry
                ' ScanModel = True
            End If
            
        'ElseIf coObject.GetAppData Mod 100 = CSGEntityType.CSGEBone Then
        '    fileBoneInfo cgExportGroup, iFile
        End If
    Next lngObject
    
    If Not coX Is Nothing Then
        If coX.GetPointCount > 0 Then
            ScanModel = True
        End If
    End If
    
    
    ' IF ANY CHILD OR THIS GROUP HAS GEOM, ADD TO LIST
    If ScanModel Then
        
        head.NumInstances = head.NumInstances + 1
        
        Set selG.cMesh = coX
        
        parent.children.Add selG
                
        ' custom group name
        s = Trim$(cgExportGroup.GetCustomFieldValue(iGrpId))
        
        If LenB(s) = 0 Then
            ' lowercase convert removed
            s = cgExportGroup.Name
            
            ' remove number from custom lods
            If lods = custom And InStr(s, ".") > 0 Then
                s = Left$(s, InStr(s, ".") - 1)
            End If
            
        End If
        
        parts = Split(s, "_")
        
        If UBound(parts) > 1 Then
            selG.GrpName = s
            ' not numeric?
            If Not (IsNumeric(parts(0)) And IsNumeric(parts(1))) Then
                selG.GrpName = lod & "_" & oDist(dist) & "_" & s
                
            ElseIf lods = Auto Then
                ' override if auto lods
                selG.GrpName = lod & "_" & oDist(dist) & "_" & parts(2)
                If UBound(parts) > 2 Then selG.GrpName = selG.GrpName & "_" & parts(3)
                If UBound(parts) > 3 Then selG.GrpName = selG.GrpName & "_" & parts(4)
            Else
            
            End If
        Else
            selG.GrpName = lod & "_" & oDist(dist) & "_" & s
        End If
        
        'Debug.Print selG.GrpName
        f.AddList selG.GrpName
        
        ' geometry could still be empty
        head.NumGeometry = head.NumGeometry + 1
        
        ' update materials list
        If Not coX Is Nothing Then
        
            If InStr(s, "shadow") > 0 Then coX.Crease2 0
            coX.OptimizeMaterials
            For i = 0 To coX.GetMaterialCount - 1
                FindMaterial ConvertMaterial(coX.GetMaterial(i))
            Next
        End If
        
    End If
    
    Set coX = Nothing
    
End Function

Private Function oDist(x As Long) As String
    oDist = Right$(CStr(x + 10000), 4)
End Function

Private Sub ExportMesh(g As selGroup, id As Long)
    
    Dim puv() As CSGVector
    Dim uv() As CSGUV
    Dim fm() As CSGMaterial
    Dim npuv As Long
    Dim n() As CSGVector
    Dim nn As Long
    Dim fd() As CSGFaceAttributes
    Dim nfd As Long
    Dim nfInd As Long
    Dim nTri As Long
    Dim nuv As Long, nfm As Long
    
    Dim v1 As D3DVECTOR, v2 As D3DVECTOR, v0 As D3DVECTOR, vx As D3DVECTOR
    Dim p1 As Long, p2 As Long, P3 As Long
    
    Dim v As IGVertex
    Dim t As IGTriangle
    
    Dim o As CSGShape
    
    Dim l As Long, k As Long, j As Long
    
    
    With geom(id)
        .IsSkinned = 0
        .NumTriangles = 0
        .NumVertices = 0
    
        Set o = g.cMesh
        
        'o.GetVisual7 True, puv, npuv, n, nn, uv, nuv, fd, nfd, fm, nfm
        o.GetGeometry True, True, False, fm, nfm, puv, npuv, n, nn, uv, nuv, fd, nfd
        
        nTri = nfd
        ' geometry next
        ' temp fix to test export
        GetBoundingBox .BoundingBox, g
    
    End With
    
    ReDim geomTri(id).Tris(nTri - 1)
    ReDim geomVert(id).Verts(nTri * 3 - 1)

    v.Colour.a = 1!
    v.Colour.r = 1!
    v.Colour.g = 1!
    v.Colour.b = 1!
    
    'For l = 0 To nn - 1
    '    Debug.Print l, n(l).x, n(l).y, n(l).z
    'Next
    
    k = -1
    For l = 0 To nTri - 1 'Step -1  'o.GetFaceCount - 1
        
        ' all materials should be on the list already
        If g.Added Then
            v.Material = 0
        Else
            v.Material = FindMaterial(ConvertMaterial(fm(fd(l).MaterialID)))
        End If
        
        t.Material = v.Material
        t.Normal.w = 1!
    
        v.NumBones = 0
        If Not fm(fd(l).MaterialID).Texture Is Nothing Then v.NumValidUVs = 1
        
        ' no of faces
        'nfInd = l * 10
        
        p1 = fd(l).PointList(2).PointID 'fd(nfInd + 7)
        p2 = fd(l).PointList(2).NormalID 'fd(nfInd + 8)
        P3 = fd(l).PointList(2).TextureCoordinateListID(0) 'fd(nfInd + 9)
        v.Point.x = puv(p1).x * mScaleFactor
        v.Point.y = puv(p1).y * mScaleFactor
        v.Point.z = puv(p1).z * mScaleFactor
        v.uv(0).x = uv(P3).U
        v.uv(0).y = uv(P3).v
        v.Normal.x = n(p2).x
        v.Normal.y = n(p2).y
        v.Normal.z = n(p2).z
        
        v1.x = v.Point.x
        v1.y = v.Point.y
        v1.z = v.Point.z
        
        t.Vertex(1) = FindVert(id, v)
        
        'p1 = fd(nfInd + 4)
        'p2 = fd(nfInd + 5)
        'P3 = fd(nfInd + 6)
        p1 = fd(l).PointList(1).PointID 'fd(nfInd + 7)
        p2 = fd(l).PointList(1).NormalID 'fd(nfInd + 8)
        P3 = fd(l).PointList(1).TextureCoordinateListID(0) 'fd(nfInd + 9)
        v.Point.x = puv(p1).x * mScaleFactor
        v.Point.y = puv(p1).y * mScaleFactor
        v.Point.z = puv(p1).z * mScaleFactor
        v.uv(0).x = uv(P3).U
        v.uv(0).y = uv(P3).v
        v.Normal.x = n(p2).x
        v.Normal.y = n(p2).y
        v.Normal.z = n(p2).z
        
        v2.x = v.Point.x
        v2.y = v.Point.y
        v2.z = v.Point.z
        
        t.Vertex(2) = FindVert(id, v)
        
        'p1 = fd(nfInd + 1)
        'p2 = fd(nfInd + 2)
        'P3 = fd(nfInd + 3)
        p1 = fd(l).PointList(0).PointID 'fd(nfInd + 7)
        p2 = fd(l).PointList(0).NormalID 'fd(nfInd + 8)
        P3 = fd(l).PointList(0).TextureCoordinateListID(0) 'fd(nfInd + 9)
        v.Point.x = puv(p1).x * mScaleFactor
        v.Point.y = puv(p1).y * mScaleFactor
        v.Point.z = puv(p1).z * mScaleFactor
        v.uv(0).x = uv(P3).U
        v.uv(0).y = uv(P3).v
        v.Normal.x = n(p2).x
        v.Normal.y = n(p2).y
        v.Normal.z = n(p2).z
        v0.x = v.Point.x
        v0.y = v.Point.y
        v0.z = v.Point.z
        
        t.Vertex(0) = FindVert(id, v)
        
        If k <> p1 Then
            k = p1
            t.HiddenEdges = 1
        Else
            If l < (nTri - 1) Then
                'If fd(nfInd + 11) = k Then
                If fd(l + 1).PointList(0).PointID = k Then
                    t.HiddenEdges = 5
                Else
                    t.HiddenEdges = 4
                End If
            Else
                t.HiddenEdges = 4
            End If
        End If
            
        ' calc face normal
        D3DXVec3Subtract v1, v0, v1
        D3DXVec3Subtract v2, v2, v0
        D3DXVec3Cross vx, v1, v2
        If vx.x <> 0 Or vx.y <> 0 Or vx.z <> 0 Then
            D3DXVec3Normalize vx, vx
        End If
        
        'Debug.Print "n", vx.x, vx.y, vx.z
        
        t.Normal.x = vx.x
        t.Normal.y = vx.y
        t.Normal.z = vx.z
        
        geomTri(id).Tris(geom(id).NumTriangles) = t
        geom(id).NumTriangles = geom(id).NumTriangles + 1
                
    Next

    ReDim Preserve geomVert(id).Verts(geom(id).NumVertices - 1)

End Sub


Private Sub ToByte(ByRef arr() As Byte, ByRef s As String)
    Dim i As Long
    
    For i = 0 To Len(s) - 1
        arr(i) = Asc(Mid$(s, i + 1))
    Next
    If i < UBound(arr) Then arr(i) = 0
    
End Sub

' custom lods?
Private Sub FindLods(g As CSGGroup)
    Dim s As String, s1 As String, lname As Long
    Dim i As Long, dist As Long, j As Long, k As Long
    Dim root As CSGGroupArray
    Dim gx As CSGGroup
    
    Set root = CSG.ApplicationState.Scene.GetChildren
    
    s = LCase$(g.Name)
    lname = Len(s)
    nCustom = 1
    Set gcustom(0) = g
    
    For i = 0 To root.GetSize - 1
        Set gx = root.GetElement(i)
        s1 = LCase$(gx.Name)
        If Left$(s1, lname) = s Then
            dist = GetDist(s1, lname)
            If dist > 0 Then
                For j = 1 To nCustom - 1
                    If GetDist(gcustom(j).Name, lname) > dist Then Exit For
                Next
                
                For k = nCustom To j Step -1
                    Set gcustom(k) = gcustom(k - 1)
                Next
                Set gcustom(j) = gx
                nCustom = nCustom + 1
            End If
        End If
    Next
    
End Sub

' return dist or 0 if error
Private Function GetDist(s As String, l As Long) As Long
    If IsNumeric(Mid$(s, l + 2)) Then GetDist = CLng(Mid$(s, l + 2))
End Function
' get triangle count from array
Private Function GetTriCount(Count As Long, fd() As Long) As Long
    Dim l As Long
    Dim p As Long ' = 0
    ' just incase
    On Error Resume Next
    ' for each face
    For l = 0 To Count - 1
        GetTriCount = GetTriCount + fd(p) - 2
        ' skip points and normals
        p = p + fd(p) * 2 + 1
    Next
End Function

Private Function SameVertex(lhs As IGVertex, rhs As IGVertex) As Boolean
        Dim i As Long

        SameVertex = False
        ' check positional absolute
        If (lhs.Point.x <> rhs.Point.x) Then Exit Function
        If (lhs.Point.y <> rhs.Point.y) Then Exit Function
        If (lhs.Point.z <> rhs.Point.z) Then Exit Function

        If (lhs.NumValidUVs <> rhs.NumValidUVs) Then Exit Function
        If (lhs.NumBones <> rhs.NumBones) Then Exit Function

        If (lhs.Material <> rhs.Material) Then Exit Function

        ' weld normal
        If (Abs(rhs.Normal.x - lhs.Normal.x) >= gVertexWeldNormalThreshold) Then Exit Function
        If (Abs(rhs.Normal.y - lhs.Normal.y) >= gVertexWeldNormalThreshold) Then Exit Function
        If (Abs(rhs.Normal.z - lhs.Normal.z) >= gVertexWeldNormalThreshold) Then Exit Function

        ' weld colour
        If (Abs(rhs.Colour.r - lhs.Colour.r) >= gVertexWeldColourThreshold) Then Exit Function
        If (Abs(rhs.Colour.g - lhs.Colour.g) >= gVertexWeldColourThreshold) Then Exit Function
        If (Abs(rhs.Colour.b - lhs.Colour.b) >= gVertexWeldColourThreshold) Then Exit Function
        If (Abs(rhs.Colour.a - lhs.Colour.a) >= gVertexWeldColourThreshold) Then Exit Function

        ' check UVs
        For i = 0 To lhs.NumValidUVs - 1
            If (Abs(rhs.uv(i).x - lhs.uv(i).x) >= gVertexWeldUVThreshold) Then Exit Function
            If (Abs(rhs.uv(i).y - lhs.uv(i).y) >= gVertexWeldUVThreshold) Then Exit Function
        Next

        ' check bones
        For i = 0 To lhs.NumBones - 1
            If (lhs.BoneBinding(i).Weight <> rhs.BoneBinding(i).Weight) Then Exit Function
            If (lhs.BoneBinding(i).Bone <> rhs.BoneBinding(i).Bone) Then Exit Function
        Next

        SameVertex = True

End Function

Private Function SameColour(lhs As Colour, rhs As Colour) As Boolean
    SameColour = False
    With lhs
        If Abs(.a - rhs.a) >= gVertexWeldColourThreshold Then Exit Function
        If Abs(.r - rhs.r) >= gVertexWeldColourThreshold Then Exit Function
        If Abs(.g - rhs.g) >= gVertexWeldColourThreshold Then Exit Function
        If Abs(.b - rhs.b) >= gVertexWeldColourThreshold Then Exit Function
    End With
    SameColour = True
End Function

Private Function SameMaterial(lhs As IGMaterial, rhs As IGMaterial) As Boolean
    SameMaterial = False
    Dim i As Long
    With lhs
        If .AlphaTestMode <> rhs.AlphaTestMode Then Exit Function
        If .BackfaceCull <> rhs.BackfaceCull Then Exit Function
        If .NeverOcclude <> rhs.NeverOcclude Then Exit Function
        If .NumRenderStages <> rhs.NumRenderStages Then Exit Function
        If Not SameByteString(.ShaderName, rhs.ShaderName) Then Exit Function
        If .SpecularPower <> rhs.SpecularPower Then Exit Function
        If .TwoSided <> rhs.TwoSided Then Exit Function
        If .ViewFacing <> rhs.ViewFacing Then Exit Function
        If .ZBias <> rhs.ZBias Then Exit Function
        If .ZBufferMode <> rhs.ZBufferMode Then Exit Function
        If .AdditiveAlphaStrength <> rhs.AdditiveAlphaStrength Then Exit Function
        If .EmissiveStrength <> rhs.EmissiveStrength Then Exit Function
        If .SortPriority <> rhs.SortPriority Then Exit Function
        If Not SameColour(.Ambient, rhs.Ambient) Then Exit Function
        If Not SameColour(.Diffuse, rhs.Diffuse) Then Exit Function
        If Not SameColour(.Emissive, rhs.Emissive) Then Exit Function
        If Not SameColour(.Specular, rhs.Specular) Then Exit Function
        
        For i = 0 To .NumRenderStages - 1
            If .RenderStage(i).mTextureName <> rhs.RenderStage(i).mTextureName Then Exit Function
            If .RenderStage(i).mUVOperation <> rhs.RenderStage(i).mUVOperation Then Exit Function
            If .RenderStage(i).mAnimateUVs <> rhs.RenderStage(i).mAnimateUVs Then Exit Function
            If .RenderStage(i).mFilterMode <> rhs.RenderStage(i).mFilterMode Then Exit Function
            If .RenderStage(i).mScrollUVs <> rhs.RenderStage(i).mScrollUVs Then Exit Function
            If .RenderStage(i).mMipLODBias <> rhs.RenderStage(i).mMipLODBias Then Exit Function
            If .RenderStage(i).mUVOperation <> rhs.RenderStage(i).mUVOperation Then Exit Function
            If .RenderStage(i).mArguments(0) <> rhs.RenderStage(i).mArguments(0) Then Exit Function
            If .RenderStage(i).mArguments(1) <> rhs.RenderStage(i).mArguments(1) Then Exit Function
            If .RenderStage(i).mArguments(2) <> rhs.RenderStage(i).mArguments(2) Then Exit Function
            If .RenderStage(i).mAnimateUVs <> 0 Or .RenderStage(i).mScrollUVs <> 0 Then
                If .RenderStage(i).mFPS <> rhs.RenderStage(i).mFPS Then Exit Function
                If .RenderStage(i).mNumFrames <> rhs.RenderStage(i).mNumFrames Then Exit Function
                If .RenderStage(i).mScrollU <> rhs.RenderStage(i).mScrollU Then Exit Function
                If .RenderStage(i).mScrollV <> rhs.RenderStage(i).mScrollV Then Exit Function
            End If
        Next
        If Not SameByteString(.SurfaceType, rhs.SurfaceType) Then Exit Function
        
    End With
    SameMaterial = True

End Function

Private Function SameByteString(lhs() As Byte, rhs() As Byte) As Boolean
    Dim i As Long
    SameByteString = False
    For i = 0 To UBound(lhs)
        If lhs(i) <> rhs(i) Then Exit Function
        ' string terminator
        If lhs(i) = 0 Then Exit For
    Next
    SameByteString = True
End Function

Private Function FindMaterial(m As IGMaterial) As Long
    Dim i As Long
    
    For i = 0 To head.NumMaterials - 1
        If SameMaterial(materials(i), m) Then
            ' found - return index
            FindMaterial = i
            Exit Function
        End If
    Next
    
    ' store in array
    FindMaterial = head.NumMaterials
    If LCase$(Replace(StrConv(m.ShaderName, vbUnicode), Chr$(0), "")) = "stencilshadow.fx" Then
        ToByte m.mName, "shadow_material" & head.NumMaterials
    ElseIf LCase$(Replace(StrConv(m.ShaderName, vbUnicode), Chr$(0), "")) = "trainglassweathereffects.fx" Then
        ToByte m.mName, "weatherglass_1"
    Else
        ToByte m.mName, "material" & head.NumMaterials
    End If
    
    materials(head.NumMaterials) = m
    head.NumMaterials = head.NumMaterials + 1
    
End Function

Private Function FindVert(id As Long, v As IGVertex) As Long
    Dim i As Long
    
    For i = 0 To geom(id).NumVertices - 1
        If SameVertex(geomVert(id).Verts(i), v) Then
            ' found - return index
            FindVert = i
            Exit Function
        End If
    Next
    
    ' store in array
    FindVert = geom(id).NumVertices
    geomVert(id).Verts(geom(id).NumVertices) = v
    geom(id).NumVertices = geom(id).NumVertices + 1
    
End Function


Private Function ConvertMaterial(m As CSGMaterial) As IGMaterial
    Dim shader As String, Tx As String, aPrio As String, matOptions As String
    Dim TexName As String, s As String
    Dim cTex As CSGTexture, iRenderStages As Long
    
    shader = m.GetCustomFieldValue(iShaderId)
    Tx = LCase$(m.GetCustomFieldValue(iTxId))
    aPrio = m.GetCustomFieldValue(iAPrId)
    
    ' load up extra options
    unpackOptions m.GetCustomFieldValue(iMatId)
    
    If LenB(shader) = 0 Then shader = "TexDiff"
    
    Set cTex = m.Texture
    
    With ConvertMaterial
    
        ToByte .ShaderName, shader
        .AdditiveAlphaStrength = 128
        
        .AlphaTestMode = 0
        If Tx = "transparency" Then .AlphaTestMode = 1
        
        m.x_GetAmbient .Ambient.r, .Ambient.g, .Ambient.b
        
        m.x_GetEmissive .Emissive.r, .Emissive.g, .Emissive.b
        If .Emissive.r < 0.04 Then .Emissive.r = 0!
        If .Emissive.g < 0.04 Then .Emissive.g = 0!
        If .Emissive.b < 0.04 Then .Emissive.b = 0!
        
        'm.GetSpecular .Specular.r, .Specular.g, .Specular.b
        .Ambient.a = 1!
        .Emissive.a = 1!
        .EmissiveStrength = 1
        
        If IsNumeric(aPrio) Then
            .SortPriority = CLng(aPrio)
        End If
        
        .LMCastShadows = 1
        .LMGenerateShadows = 1
        .LMKeepVertexColours = 0
        .LMTexelsPerMetre = 4!
        
        m.x_GetColorRGBA .Diffuse.r, .Diffuse.g, .Diffuse.b, .Diffuse.a
        If .Diffuse.a > 0.949! Then .Diffuse.a = 1!
        
        .Specular = .Diffuse
        
        .BackfaceCull = 1
        .TwoSided = 0
        
        If m.power < 0.001 Then
            .SpecularPower = 0!
        Else
            .SpecularPower = 1!
        End If
        
        ToByte .SurfaceType, "NO COLLIDE"
        ToByte .LightGlowType, "HEADLAMP"
        .PulseGlowConfig.TargCol.r = 0.7843138
        .PulseGlowConfig.TargCol.g = 0.7843138
        .PulseGlowConfig.TargCol.b = 1!
        .PulseGlowConfig.TargCol.a = 1!
        
        .PulseGlowConfig.Period = 5!
        .PulseGlowConfig.Amplitude = 1!
        ToByte .PulseGlowConfig.SeqMode, "TRAFFIC"
        .PulseGlowConfig.RptTimeMin = 1!
        .PulseGlowConfig.RptTimeMax = 5!
        .PulseGlowConfig.ExeTimeMin = 1!
        .PulseGlowConfig.ExeTimeMax = 5!

        
        .ZBias = 0
        .ZBufferMode = 1
        If Tx = "translucency" Then .ZBufferMode = 3
        .VisMod = 100
        .ViewFacing = 0
        
        If InStr(shader, "ViewFacing") > 0 Then
            If InStr(shader, "Upright") > 0 Then
                .ViewFacing = 2
            Else
                .ViewFacing = 1
            End If
        End If
        .NeverOcclude = 0
        
        s = FindOpt("zbias")
        If LenB(s) > 0 Then .ZBias = CLng(s)
        s = FindOpt("zbuffermode")
        If LenB(s) > 0 Then .ZBufferMode = CLng(s)
        s = FindOpt("vismod")
        If LenB(s) > 0 Then .VisMod = CLng(s)
        s = FindOpt("viewfacing")
        If LenB(s) > 0 Then .ViewFacing = CLng(s)
        s = FindOpt("neverocclude")
        If LenB(s) > 0 Then .NeverOcclude = CLng(s)
        s = FindOpt("specularpower")
        If LenB(s) > 0 Then .SpecularPower = CSng(s)
        s = FindOpt("TwoSided")
        If LenB(s) > 0 Then .TwoSided = CLng(s)
        s = FindOpt("BackFacecull")
        If LenB(s) > 0 Then .BackfaceCull = CLng(s)
        
        ' base material stage
        .NumRenderStages = 1
        .RenderStage(0).mAnimateUVs = 0
        .RenderStage(0).mFilterMode = 3
        .RenderStage(0).mFPS = 20
        .RenderStage(0).mNumFrames = 0
        .RenderStage(0).mScrollU = 0
        .RenderStage(0).mScrollUVs = 0
        .RenderStage(0).mScrollV = 0
        .RenderStage(0).mUVOperation = 0
        .RenderStage(0).mMipLODBias = -2
        
        ' first arg for specular shaders is exponent
        If .SpecularPower > 0 And InStr(shader, "Spec") Then
            .RenderStage(0).mArguments(0) = (250 - m.power) / 2
        Else
            .SpecularPower = 0!
        End If
    
    
        If Not cTex Is Nothing Then
            TexName = cTex.TextureName
            If LenB(TexName) > 4 Then
                .RenderStage(0).mTextureName = AddTex(TexName, FindOpt("texturepath"))
            End If
            If InStr(shader, "Shadow") > 0 Then
                .RenderStage(0).mMipLODBias = 0!
            End If

            If InStr(shader, "WeatherEffects") > 0 Then
                iRenderStages = iRenderStages + 1
                .NumRenderStages = 2
                .RenderStage(1).mAnimateUVs = 0
                .RenderStage(1).mFilterMode = 3
                .RenderStage(1).mFPS = 20
                .RenderStage(1).mNumFrames = 0
                .RenderStage(1).mScrollU = 0
                .RenderStage(1).mScrollUVs = 0
                .RenderStage(1).mScrollV = 0
                .RenderStage(1).mUVOperation = 0
                .RenderStage(1).mMipLODBias = -1
                .RenderStage(1).mTextureName = .RenderStage(0).mTextureName
                SetRSOptions .RenderStage(iRenderStages), iRenderStages
            End If

            If InStr(shader, "Bump") > 0 Or (InStr(shader, "WeatherEffects") > 0) Then
                iRenderStages = iRenderStages + 1
                .NumRenderStages = iRenderStages + 1
                .RenderStage(iRenderStages).mAnimateUVs = 0
                .RenderStage(iRenderStages).mFilterMode = 3
                .RenderStage(iRenderStages).mFPS = 20
                .RenderStage(iRenderStages).mNumFrames = 0
                .RenderStage(iRenderStages).mScrollU = 0
                .RenderStage(iRenderStages).mScrollUVs = 0
                .RenderStage(iRenderStages).mScrollV = 0
                .RenderStage(iRenderStages).mUVOperation = 0
                .RenderStage(iRenderStages).mMipLODBias = -1
                TexName = cTex.BumpMapName
                If LenB(TexName) > 4 Then
                    .RenderStage(iRenderStages).mTextureName = AddTex(TexName, FindOpt("texturepath"))
                End If
                SetRSOptions .RenderStage(iRenderStages), iRenderStages
            End If
            
            If InStr(shader, "Specular") > 0 Then
                iRenderStages = iRenderStages + 1
                .NumRenderStages = iRenderStages + 1
                .RenderStage(iRenderStages).mAnimateUVs = 0
                .RenderStage(iRenderStages).mFilterMode = 3
                .RenderStage(iRenderStages).mFPS = 20
                .RenderStage(iRenderStages).mNumFrames = 0
                .RenderStage(iRenderStages).mScrollU = 0
                .RenderStage(iRenderStages).mScrollUVs = 0
                .RenderStage(iRenderStages).mScrollV = 0
                .RenderStage(iRenderStages).mUVOperation = 0
                .RenderStage(iRenderStages).mMipLODBias = 0
                TexName = cTex.SpecularMapName
                If LenB(TexName) > 4 Then
                    .RenderStage(iRenderStages).mTextureName = AddTex(TexName, FindOpt("texturepath"))
                End If
                SetRSOptions .RenderStage(iRenderStages), iRenderStages
            End If
            
            If InStr(shader, "LightMap") > 0 Then
                iRenderStages = iRenderStages + 1
                .NumRenderStages = iRenderStages + 1
                .RenderStage(iRenderStages).mAnimateUVs = 0
                .RenderStage(iRenderStages).mFilterMode = 3
                .RenderStage(iRenderStages).mFPS = 20
                .RenderStage(iRenderStages).mNumFrames = 0
                .RenderStage(iRenderStages).mScrollU = 0
                .RenderStage(iRenderStages).mScrollUVs = 0
                .RenderStage(iRenderStages).mScrollV = 0
                .RenderStage(iRenderStages).mUVOperation = 0
                .RenderStage(iRenderStages).mMipLODBias = 0
                TexName = cTex.TextureOverlayName
                If LenB(TexName) > 4 Then
                    .RenderStage(iRenderStages).mTextureName = AddTex(TexName, FindOpt("texturepath"))
                End If
                SetRSOptions .RenderStage(iRenderStages), iRenderStages
            End If
            
            If InStr(shader, "Env") > 0 Or InStr(shader, "Glass") Or InStr(shader, "Water") > 0 Then
                iRenderStages = iRenderStages + 1
                .NumRenderStages = iRenderStages + 1
                .RenderStage(iRenderStages).mAnimateUVs = 0
                .RenderStage(iRenderStages).mFilterMode = 3
                .RenderStage(iRenderStages).mFPS = 20
                .RenderStage(iRenderStages).mNumFrames = 0
                .RenderStage(iRenderStages).mScrollU = 0
                .RenderStage(iRenderStages).mScrollUVs = 0
                .RenderStage(iRenderStages).mScrollV = 0
                .RenderStage(iRenderStages).mUVOperation = 0
                .RenderStage(iRenderStages).mMipLODBias = 0
                TexName = cTex.EnvironmentMapName
                If LenB(TexName) > 4 Then
                    .RenderStage(iRenderStages).mTextureName = AddTex(TexName, FindOpt("texturepath"))
                End If
                SetRSOptions .RenderStage(iRenderStages), iRenderStages
            End If
                        
        End If
        
        SetRSOptions .RenderStage(0), 0
        
    End With
End Function

Private Sub SetRSOptions(ByRef r As IGRenderStage, n As Long)
    Dim s As String
    
    s = FindOpt("r" & n & "AnimateUV")
    If LenB(s) > 0 Then r.mAnimateUVs = CLng(s)
    s = FindOpt("r" & n & "filtermode")
    If LenB(s) > 0 Then r.mFilterMode = CLng(s)
    s = FindOpt("r" & n & "fps")
    If LenB(s) > 0 Then r.mFPS = CLng(s)
    s = FindOpt("r" & n & "frames")
    If LenB(s) > 0 Then r.mNumFrames = CLng(s)
    s = FindOpt("r" & n & "ScrollUVs")
    If LenB(s) > 0 Then r.mScrollUVs = CLng(s)
    s = FindOpt("r" & n & "scrollu")
    If LenB(s) > 0 Then r.mScrollU = CSng(s)
    s = FindOpt("r" & n & "scrollv")
    If LenB(s) > 0 Then r.mScrollV = CSng(s)
    s = FindOpt("r" & n & "miplodbias")
    If LenB(s) > 0 Then r.mMipLODBias = CSng(s)
    s = FindOpt("r" & n & "arg0")
    If LenB(s) > 0 Then r.mArguments(0) = CSng(s)
    s = FindOpt("r" & n & "arg1")
    If LenB(s) > 0 Then r.mArguments(1) = CSng(s)
    s = FindOpt("r" & n & "arg2")
    If LenB(s) > 0 Then r.mArguments(2) = CSng(s)
    s = FindOpt("r" & n & "arg3")
    If LenB(s) > 0 Then r.mArguments(3) = CSng(s)
    s = FindOpt("r" & n & "arg4")
    If LenB(s) > 0 Then r.mArguments(4) = CSng(s)

End Sub

'add a texture file
Private Function AddTex(s As String, Optional path As String = "textures\") As Long
    
    Dim i As Long
    
    If LenB(path) = 0 Then path = "textures\"
    If Right$(path, 1) <> "\" Then path = path & "\"
    
    i = InStrRev(s, ".")
    s = path & LCase$(Mid$(s, 1, i - 1))
    For i = 0 To TxNam.mNumStrings - 1
        If Tx(i) = s Then
            AddTex = (i + 1)
            Exit Function
        End If
    Next
    
    Tx(TxNam.mNumStrings) = s
    TxNam.mNumStrings = TxNam.mNumStrings + 1
    AddTex = TxNam.mNumStrings
End Function


Private Function SizeOK(o As CSGShape, dist As Long) As Boolean
    Dim b As CSGMinMaxVector, minsize As Single, under As Boolean, fSize As Single
    
    If dist <= 100 Then
        SizeOK = True
        Exit Function
    'ElseIf dist <= 400 Then
    '    minsize = 0.1
    'Else ' 1000m
    '    minsize = 0.5
    End If
    
    b = o.GetBoundingBox
    
    minsize = dist / 1200 ' so at 100-400m, 0.4m disappears, 400-1000 1m goes
    
    ' look for 2 dimensions under minsize
    under = (b.max.x - b.min.x) * mScaleFactor < minsize
    
    fSize = (b.max.y - b.min.y) * mScaleFactor
    
    If under Then
        If fSize < minsize Then Exit Function
    Else
        under = fSize < minsize
    End If
    
    fSize = (b.max.z - b.min.z) * mScaleFactor
    
    If under Then
        If fSize < minsize Then Exit Function
    End If
    
    SizeOK = True
    
End Function

Private Sub GetBoundingBox(ByRef bb As bbox, g As selGroup)
    Dim b As CSGMinMaxVector
    b = g.cMesh.GetBoundingBox
    bb.min.x = b.min.x * mScaleFactor
    bb.max.x = b.max.x * mScaleFactor
    bb.min.y = b.min.y * mScaleFactor
    bb.max.y = b.max.y * mScaleFactor
    bb.min.z = b.min.z * mScaleFactor
    bb.max.z = b.max.z * mScaleFactor
End Sub

Private Sub unpackOptions(s As String)
    Dim o() As String, i As Long
    Dim p() As String
    If LenB(s) > 0 Then
        o = Split(s, ";")
        ReDim MatOpt(UBound(o), 1)
        For i = 0 To UBound(o)
            If InStr(o(i), "=") > 0 Then
                p = Split(o(i), "=")
                MatOpt(i, 0) = LCase$(p(0))
                MatOpt(i, 1) = p(1)
            End If
        Next
    Else
        ReDim MatOpt(0, 1)
    End If
End Sub

Private Function FindOpt(s As String) As String
    Dim i As Long
    s = LCase$(s)
    For i = 0 To UBound(MatOpt)
        If s = MatOpt(i, 0) Then
            FindOpt = MatOpt(i, 1)
            Exit Function
        End If
    Next
    ' otherwise return ""
End Function

' untextured?
Private Function InvalidMaterial(m As CSGMaterial) As Boolean
    InvalidMaterial = True
    
    If m.Texture Is Nothing Then Exit Function
    
    If Len(m.Texture.TextureName) < 5 Then Exit Function
    
    InvalidMaterial = False
End Function
